/*
 * 推送消息记录
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.BsModels;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MsgPushController : BaseController
    {
        public MsgPushController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["BsSqlConnStr"].ToString();
        }

        #region 推送消息记录列表

        /// <summary>
        /// 根据条件查询推送消息记录列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MsgPush data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            string Condition = "";
            Condition += "ClientType:\"" + data.ClientType + "\",";
Condition += "Title:\"" + data.Title + "\",";
Condition += "TemplateId:\"" + data.TemplateId + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询推送消息记录列表

        /// <summary>
        /// 推送消息记录列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MsgPush data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("ClientType", "1"); //客户端类型
Fields.Add("CreateDate", "3"); //时间
Fields.Add("Title", "2"); //推送标题
Fields.Add("TemplateId", "1"); //模板

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).IndexData("MsgPush", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["TemplateId"] = RelationClass.GetMsgTemplateInfo(int.Parse(dic["TemplateId"].ToString()));

            }
            return Json(obj);
        }

        #endregion

        #region 增加推送消息记录

        /// <summary>
        /// 增加或修改推送消息记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加推送消息记录

        /// <summary>
        /// 增加或修改推送消息记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MsgPush data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("ClientType", data.ClientType); //客户端类型
Fields.Add("Url", data.Url); //链接地址
Fields.Add("Title", data.Title); //推送标题
Fields.Add("Details", data.Details); //推送内容
Fields.Add("IsSilent", data.IsSilent); //静音推送
Fields.Add("Devices", data.Devices); //设备号
Fields.Add("TemplateId", data.TemplateId); //模板
Fields.Add("AutoPushDate", data.AutoPushDate); //定时推送时间
Fields.Add("Mobiles", data.Mobiles); //手机号

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Add("MsgPush", Fields, 0);
            AddSysLog(data.Id.ToString(), "MsgPush", "add");
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改推送消息记录

        /// <summary>
        /// 增加或修改推送消息记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            MsgPush editData = bsdb.MsgPush.FirstOrDefault(m => m.Id == Id) ?? new MsgPush();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改推送消息记录

        /// <summary>
        /// 增加或修改推送消息记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MsgPush data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("ClientType", data.ClientType); //客户端类型
Fields.Add("Url", data.Url); //链接地址
Fields.Add("Title", data.Title); //推送标题
Fields.Add("Details", data.Details); //推送内容
Fields.Add("IsSilent", data.IsSilent); //静音推送
Fields.Add("Devices", data.Devices); //设备号
Fields.Add("TemplateId", data.TemplateId); //模板
Fields.Add("AutoPushDate", data.AutoPushDate); //定时推送时间
Fields.Add("Mobiles", data.Mobiles); //手机号

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgPush", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"MsgPush","update");
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除推送消息记录信息

        /// <summary>
        /// 删除推送消息记录信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgPush","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgPush", Fields, id);
            }
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgPush","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgPush", Fields, id);
            }
            bsdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgPush","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgPush", Fields, id);
            }
            bsdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Sort("MsgPush", Sort, Id);
            
            AddSysLog(Id.ToString(), "MsgPush", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                bsdb.MsgPush.Add(new MsgPush()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                bsdb.SaveChanges();
            }
            AddSysLog("0", "MsgPush", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MsgPush data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ClientType", "1"); //客户端类型
Fields.Add("CreateDate", "3"); //时间
Fields.Add("Title", "2"); //推送标题
Fields.Add("TemplateId", "1"); //模板

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).IndexData("MsgPush", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["TemplateId"] = RelationClass.GetMsgTemplateInfo(int.Parse(dic["TemplateId"].ToString()));

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MsgPush", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
